<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import {brush} from 'd3-brush';
  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";

  export let selectPoints = [];
  export let selectPointsLocal = [];

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));
  
 // precompute the data points coordinates
  const coords = data.map((d)=> {
    return {x: xScale(x(d)), y: yScale(y(d))}
  });
  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;
  $: if (range) {
    const [ [x0, y0], [x1, y1] ] = range;
    selectPointsLocal = coords.map((d) => (x0 < d.x && d.x < x1 && y0 < d.y && d.y < y1)); 
  } else {
    selectPointsLocal = coords.map(() => true);
    
  }
  $: console.log(range)
  function addBrush(element) {
    const brusher = brush()
     .on('start', (event)=> {
       range = event.selection;
     })
     .on('brush', (event)=> {
       range = event.selection;
     })
     .on('end', (event)=> {
       range = event.selection;
     })
     brusher(select(element))
  }

</script>

<svg  viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    <g use:addBrush>
      {#each coords as d, i}
        <circle
          cx={d.x}
          cy={d.y}
          r={3}
          fill={selectPoints[i] ? "steelblue": "darkgrey"}
          fill-opacity={selectPoints[i] ? "0.5": "0.3"}
          stroke={selectPoints[i] ? "steelblue": "darkgrey"}
          stroke-width="1.5"
          stroke-opacity={selectPoints[i] ? "1": "0.5"}
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>
